// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef NETWORK_INTERFACE_APB_WRAPPER_HH
#define NETWORK_INTERFACE_APB_WRAPPER_HH

#include <stdint.h>
#include <systemc>
#include "network_interface.hpp"

class network_interface_apb_wrapper :
    public sc_core::sc_module
{

public:

    sc_core::sc_in< bool > pclk;
    sc_core::sc_in< bool > presetn;
    sc_core::sc_in< uint32_t > paddr;
    sc_core::sc_in< bool > psel;
    sc_core::sc_in< bool > penable;
    sc_core::sc_in< bool > pwrite;
    sc_core::sc_in< uint32_t > pwdata;
    sc_core::sc_out< bool > pready;
    sc_core::sc_out< uint32_t > prdata;
    sc_core::sc_signal< bool > clk;
    sc_core::sc_signal< bool > reset;
    sc_core::sc_signal< bool > mode;
    sc_core::sc_signal< bool > rx_data_ready;
    sc_core::sc_signal< uint32_t > rx_data;
    sc_core::sc_signal< bool > tx_data_ready;
    sc_core::sc_signal< uint32_t > tx_data;
    sc_core::sc_signal< bool > tx_data_done;

    network_interface network_interface_0;


    SC_HAS_PROCESS( network_interface_apb_wrapper );

    network_interface_apb_wrapper( sc_core::sc_module_name name_ );
    ~network_interface_apb_wrapper();


private:

    network_interface_apb_wrapper( const network_interface_apb_wrapper & );
    const network_interface_apb_wrapper& operator= ( const network_interface_apb_wrapper
         & );


    void globact_process_11();
    void globact_process_12();
    void globact_process_13();
    void globact_process_14();
    void globact_process_15();
    void globact_process_16();
    void globact_process_17();

};


#endif

